#!/usr/bin/perl

use Env qw(GMT_BIN);

use Getopt::Std;

getopts("G:", \%args);

if (@ARGV == 0)
{ die "use: grdmerge -Goutgrd GRD-file(s)

 Make sure, all the GRD files share one border among each (in the right order)
\n";
}

if (!defined($args{G})) { die "Must specify output file (-G)\n"; }

$outfn = $args{G};

$fn1 = $ARGV[0];

for ($i = 1; $i < @ARGV; $i++)
{ $fn2 = $ARGV[$i];

  $cmd = "$GMT_BIN/grdpaste $fn1 $fn2 -G$outfn";
  print "$cmd\n";
  system "$cmd";

  $fn1 = $outfn;
}
