function RscWrite(OutName,fields)

% Writes a .rsc file 
%
% RscWrite(OutName,fields)
%
% fields is a structure
%
% N. Gourmelen January 2007
% 


fieldsnames=fieldnames(fields);

fid=fopen(OutName,'w');

for ni=1:max(size(fieldsnames))
	vall=getfield(fields,fieldsnames{ni});
	if (sum(double(isalpha(vall)))==0)
		vall=num2str(vall);
	end
	fwrite(fid,sprintf('%s \n',[fieldsnames{ni},' = ',vall] ));
end

fclose(fid)	
