#include <iostream.h>
#include <fstream.h>
#include <stdio.h>
#include <stdlib.h>


int main (int argc, char *argv[]) 
{

	char 	demfile [240], intfile [240], outfile [240] ;
	unsigned char 
		*heights, *intens, *outline ;
	short   *sptr ;
	int	contint, *iptr ;
	int	i, j, ival, ns, nl, dtype, bpp, bytesppx [4]={1,2,4,4} ;
	int	bytesperline ;
	float   red [360], grn [360], blue[360] ;
	float   hval, *fptr, *newheight ;
	long    fpos ;

	if (argc < 6) {
		cout <<"usage : makeramp demfile intensfile outfile ns dtype contint " << endl ;

		return (0) ;
	}
	strcpy (demfile, *++argv) ;
	strcpy (intfile, *++argv) ;
	strcpy (outfile, *++argv) ; 
	ns = atoi (*++argv) ;
	dtype = atoi (*++argv) ;
	bytesperline = bytesppx [dtype] * ns;
	bpp = bytesppx [dtype] ;
	
	contint = atoi (*++argv) ;
	

	// assign values to the phase:
        for (i=0; i<120; i++)
        {
                red [i] = float(i) * 2. * 155./255. + 100 ;
                grn [i] = float (119. -i) * 2. * 155./255. + 100. ;
                blue [i] = 255. ;
        }
        for (i=120; i<240; i++)
        {
                ival = i - 120 ;
                red [i] = 255. ;
                grn [i] = float (ival) *  2. * 155./255. + 100. ;
                blue [i] = float (239. - i) * 2. * 155./ 255. + 100. ;
        }
        for (i=240; i<360; i++)
        {
                ival = i - 240 ;
                red [i] = float (359. - i)  * 2. * 155. / 255. + 100. ;
                grn [i] = 255. ;
                blue [i] = float (ival) * 2. * 155. / 255. + 100. ;
        }


	ifstream dfile (demfile, ios::in) ;  
	dfile.seekg (0, ios::end) ;
	fpos = dfile.tellg() ;
	nl = fpos / (bytesperline) ;
	dfile.seekg (0, ios::beg) ;
	ifstream ifile (intfile, ios::in) ;
	ofstream ofile (outfile, ios::out) ;

	heights = new unsigned char [bytesperline] ;
	newheight = new float [ns] ;
	intens = new unsigned char [ns] ;
	outline = new unsigned char [ns * 3] ;


	// get the height data and scale to something or other
	for (i=0; i<nl; i++) {
		// read in the height data
		dfile.read (heights, bytesperline) ;
		ifile.read (intens, ns) ;
		// read in the intensity data 
		switch (dtype) {
			case 0: 
				for (j=0; j<ns; j++) 
				  	*(newheight + j) = float (*(heights+j)) ;
				break ;
				
			case 1 : 
				sptr = (short *) heights ;
				for (j=0; j<ns; j++) 
				  	*(newheight + j) = float (*(sptr+j)) ;
				break ;
			case 2 :
				iptr = (int *) heights ;
				for (j=0; j<ns; j++) 
				  	*(newheight + j) = float (*(iptr+j)) ;
				break ;
			case 3 :
				fptr = (float *) heights ;
				for (j=0; j<ns; j++) 
				  	*(newheight + j) = float (*(fptr+j)) ;
				break ;
		}
				
		int itmpval, tmpval ;
		float remainder ;
		for (j=0; j<ns; j++) 
		{
			itmpval = int (*(newheight+j) / contint) ;
			remainder = *(newheight+j) - itmpval *contint ;
			if (remainder<0) remainder *= -1. ;
			tmpval = int (remainder / contint * 360.) ;
			*(outline + j * 3) = (unsigned char) (red[tmpval] * float(*(intens+j))/255.) ;
			*(outline + j * 3+1) = (unsigned char) (grn[tmpval] * float(*(intens+j))/255.) ;
			*(outline + j * 3+2) = (unsigned char) (blue [tmpval] * float(*(intens+j))/255.) ;

		}
		ofile.write (outline, ns * 3) ;

	}


	delete [] outline ;
	delete [] newheight ;
	delete [] intens ;
	delete [] heights ;

	ifile.close () ;
	ofile.close () ;
	dfile.close () ;
}







