      program bil2hgt
c   reads 16bit integer format (e.g. as arcinfo's bil format)
c   and write it as single precision (real *4, float), hgt-format  
c   (height in amp and hgt image).

      implicit none
      integer  len,line,k,j,iargc
      integer*2 array(11000)
      real*4 brray(22000)
      logical flip
      character*80 a_input,a_output,c

      if(iargc() .lt. 3) then
         write(6,*) 'usage: bil2hgt infile outfile width [flip] '
         write(6,*) 
         write(6,*) ' e.g.: bil2hgt lvdem  dem.hgt 2377   y    '
         write(6,*) ' flip: default is n              '
         stop
      end if

      call getarg(1,a_input)
      call getarg(2,a_output)
      call getarg(3,c)
      read(c,*)len

      flip=.FALSE.
      if (iargc().eq.4) then
         call getarg(4,c)
         if (c.eq.'Y' .or. c.eq.'y')  flip=.TRUE.
      endif

      open(unit=10,file=a_input,status='old',access='direct',form='unformatted',
     +     recl=2*len)
      open(unit=11,file=a_output,status='unknown',access='direct',form='unformatted',
     +     recl=8*len)

      do line=1,10000
         read(10,rec=line,err=99)(array(k),k=1,len)
         if (mod(line,100).eq.0) write(*,*) 'line: ',line
         do j=1,len
            brray(j)=real(array(j))
            brray(j+len)=real(array(j))
         enddo
         if (flip) then
            write(11,rec=line,err=99)(brray(k),k=2*len,1,-1)
         else
            write(11,rec=line,err=99)(brray(k),k=1,2*len)
         endif
      enddo

99    stop
      end
