#include <iostream.h>
#include <fstream.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


int main (int argc, char *argv[]) 
{

	char 	demfile [240], intfile [240], outfile [240] ;
	unsigned char 
		*heights, *intens, *outline ;
	short   *sptr ;
	int	contint, *iptr ;
	int	i, j, ival, ns, nl, dtype, bpp, bytesppx [4]={1,2,4,4} ;
	int	bytesperline ;
	float   red [360], grn [360], blue[360] ;
	float   hval, *fptr, *newheight, offset=0 ;
	long    fpos ;

	if (argc < 5) {
		cout <<"usage : hgt2rgb hgtfile intensfile outfile ns contint <offset=0> " << endl ;

		return (0) ;
	}
	strcpy (demfile, *++argv) ;
	strcpy (intfile, *++argv) ;
	strcpy (outfile, *++argv) ; 
	ns = atoi (*++argv) ;
	contint = atoi (*++argv) ;
	//dtype = atoi (*++argv) ;
	if (argc == 6) {
		offset = atof (*++argv) ;
	}
	dtype = 3 ;
	bytesperline = bytesppx [dtype] * ns;
	bpp = bytesppx [dtype] ;
	
	

	// assign values to the phase:
        for (i=0; i<120; i++)
        {
                red [i] = float(i) * 2. * 155./255. + 100 ;
                grn [i] = float (119. -i) * 2. * 155./255. + 100. ;
                blue [i] = 255. ;
        }
        for (i=120; i<240; i++)
        {
                ival = i - 120 ;
                red [i] = 255. ;
                grn [i] = float (ival) *  2. * 155./255. + 100. ;
                blue [i] = float (239. - i) * 2. * 155./ 255. + 100. ;
        }
        for (i=240; i<360; i++)
        {
                ival = i - 240 ;
                red [i] = float (359. - i)  * 2. * 155. / 255. + 100. ;
                grn [i] = 255. ;
                blue [i] = float (ival) * 2. * 155. / 255. + 100. ;
        }


	ifstream dfile (demfile, ios::in) ;  
	dfile.seekg (0, ios::end) ;
	fpos = dfile.tellg() ;
	nl = fpos / (bytesperline) ;
	dfile.seekg (0, ios::beg) ;
	ifstream ifile (intfile, ios::in) ;
	ofstream ofile (outfile, ios::out) ;


	heights = new unsigned char [bytesperline*2] ;
	newheight = new float [ns] ;
	intens = new unsigned char [ns] ;
	outline = new unsigned char [ns * 3] ;


	// get the height data and scale to something or other
	for (i=0; i<nl; i++) {
		// read in the height data
		dfile.read ((char *)heights, bytesperline * 2) ;
		ifile.read ((char *)intens, ns) ;

			// read in the intensity data 
			fptr = (float *) heights ;
			for (j=0; j<ns; j++) 
			{
				float checkval = *(fptr + j ) * *(fptr+ns + j) ;
				if (checkval >(-.000001) && checkval < (.00001)) *(newheight+j) = -9999. ;
				else 
			  		*(newheight + j) = float (*(fptr+j+ns))-offset ;
			}
				
		int itmpval, tmpval ;
		float remainder ;
		for (j=0; j<ns; j++) 
		{
			if (*(newheight+j) < (-9998.99999) && *(newheight+j) > (-9999.00001)) {
				*(outline+j*3) = *(intens+j) ;
				*(outline+j*3+1) =  *(intens+j) ; 
				*(outline+j*3+2) =  *(intens+j) ; 
				continue ;
			}	
			itmpval = int (*(newheight+j) / contint) ;
			remainder = *(newheight+j) - itmpval *contint ;
			if (remainder<0) remainder *= -1. ;
			tmpval = int (remainder / contint * 360.) ;
			*(outline + j * 3) = (unsigned char) (red[tmpval] * float(*(intens+j))/255.) ;
			*(outline + j * 3+1) = (unsigned char) (grn[tmpval] * float(*(intens+j))/255.) ;
			*(outline + j * 3+2) = (unsigned char) (blue [tmpval] * float(*(intens+j))/255.) ;

		}
		ofile.write ((char *)outline, ns * 3) ;

	}


	delete [] outline ;
	delete [] newheight ;
	delete [] intens ;
	delete [] heights ;

	ifile.close () ;
	ofile.close () ;
	dfile.close () ;
}







